---
title: List Roles
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/go)

[Accounts](https://developers.cloudflare.com/api/go/resources/accounts)

[Roles](https://developers.cloudflare.com/api/go/resources/accounts/subresources/roles)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# List Roles

Deprecated: Use /accounts/{account\_id}/iam/permission\_groups instead.

client.Accounts.Roles.List(ctx, params) (\*V4PagePaginationArray\[[Role](<https://developers.cloudflare.com/api/go/resources/$shared#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)>)], error)

GET/accounts/{account\_id}/roles

Get all available roles for an account.

##### Security

API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**`X-Auth-Email: user@example.com`

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**`X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194`

##### Accepted Permissions (at least one required)

`SCIM Provisioning``Account Settings Write``Account Settings Read`

##### ParametersExpand Collapse

<details>

<summary>

params RoleListParams

</summary>

AccountID param.Field\[string]

Path param: Account identifier tag.

maxLength32

minLength32

<a href="#(resource)%20accounts.roles%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20account_id">Link to this property</a>

Page param.Field\[float64]Optional

Query param: Page number of paginated results.

minimum1

<a href="#(resource)%20accounts.roles%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20page">Link to this property</a>

PerPage param.Field\[float64]Optional

Query param: Number of roles per page.

maximum50

minimum5

<a href="#(resource)%20accounts.roles%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20per_page">Link to this property</a>

</details>

[Link to this property](<#(resource)%20accounts.roles%20%3E%20(method)%20list%20%3E%20(params)%20default>)

##### ReturnsExpand Collapse

<details>

<summary>

type Role struct{…}

</summary>

ID string

Role identifier tag.

maxLength32

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20id">Link to this property</a>

Description string

Description of role’s permissions.

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20description">Link to this property</a>

Name string

Role name.

maxLength120

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20name">Link to this property</a>

<details>

<summary>

Permissions RolePermissions

</summary>

<details>

<summary>

Analytics <a href="https://developers.cloudflare.com/api/go/resources/$shared#(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)">PermissionGrant</a>Optional

</summary>

Read boolOptional

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20analytics%20%2B%20(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)%20%3E%20(property)%20read">Link to this property</a>

Write boolOptional

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20analytics%20%2B%20(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)%20%3E%20(property)%20write">Link to this property</a>

</details>

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20analytics">Link to this property</a>

<details>

<summary>

Billing <a href="https://developers.cloudflare.com/api/go/resources/$shared#(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)">PermissionGrant</a>Optional

</summary>

Read boolOptional

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20billing%20%2B%20(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)%20%3E%20(property)%20read">Link to this property</a>

Write boolOptional

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20billing%20%2B%20(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)%20%3E%20(property)%20write">Link to this property</a>

</details>

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20billing">Link to this property</a>

<details>

<summary>

CachePurge <a href="https://developers.cloudflare.com/api/go/resources/$shared#(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)">PermissionGrant</a>Optional

</summary>

Read boolOptional

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20cache_purge%20%2B%20(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)%20%3E%20(property)%20read">Link to this property</a>

Write boolOptional

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20cache_purge%20%2B%20(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)%20%3E%20(property)%20write">Link to this property</a>

</details>

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20cache_purge">Link to this property</a>

<details>

<summary>

DNS <a href="https://developers.cloudflare.com/api/go/resources/$shared#(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)">PermissionGrant</a>Optional

</summary>

Read boolOptional

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20dns%20%2B%20(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)%20%3E%20(property)%20read">Link to this property</a>

Write boolOptional

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20dns%20%2B%20(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)%20%3E%20(property)%20write">Link to this property</a>

</details>

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20dns">Link to this property</a>

<details>

<summary>

DNSRecords <a href="https://developers.cloudflare.com/api/go/resources/$shared#(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)">PermissionGrant</a>Optional

</summary>

Read boolOptional

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20dns_records%20%2B%20(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)%20%3E%20(property)%20read">Link to this property</a>

Write boolOptional

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20dns_records%20%2B%20(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)%20%3E%20(property)%20write">Link to this property</a>

</details>

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20dns_records">Link to this property</a>

<details>

<summary>

LB <a href="https://developers.cloudflare.com/api/go/resources/$shared#(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)">PermissionGrant</a>Optional

</summary>

Read boolOptional

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20lb%20%2B%20(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)%20%3E%20(property)%20read">Link to this property</a>

Write boolOptional

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20lb%20%2B%20(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)%20%3E%20(property)%20write">Link to this property</a>

</details>

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20lb">Link to this property</a>

<details>

<summary>

Logs <a href="https://developers.cloudflare.com/api/go/resources/$shared#(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)">PermissionGrant</a>Optional

</summary>

Read boolOptional

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20logs%20%2B%20(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)%20%3E%20(property)%20read">Link to this property</a>

Write boolOptional

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20logs%20%2B%20(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)%20%3E%20(property)%20write">Link to this property</a>

</details>

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20logs">Link to this property</a>

<details>

<summary>

Organization <a href="https://developers.cloudflare.com/api/go/resources/$shared#(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)">PermissionGrant</a>Optional

</summary>

Read boolOptional

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20organization%20%2B%20(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)%20%3E%20(property)%20read">Link to this property</a>

Write boolOptional

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20organization%20%2B%20(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)%20%3E%20(property)%20write">Link to this property</a>

</details>

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20organization">Link to this property</a>

<details>

<summary>

SSL <a href="https://developers.cloudflare.com/api/go/resources/$shared#(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)">PermissionGrant</a>Optional

</summary>

Read boolOptional

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20ssl%20%2B%20(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)%20%3E%20(property)%20read">Link to this property</a>

Write boolOptional

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20ssl%20%2B%20(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)%20%3E%20(property)%20write">Link to this property</a>

</details>

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20ssl">Link to this property</a>

<details>

<summary>

WAF <a href="https://developers.cloudflare.com/api/go/resources/$shared#(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)">PermissionGrant</a>Optional

</summary>

Read boolOptional

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20waf%20%2B%20(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)%20%3E%20(property)%20read">Link to this property</a>

Write boolOptional

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20waf%20%2B%20(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)%20%3E%20(property)%20write">Link to this property</a>

</details>

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20waf">Link to this property</a>

<details>

<summary>

ZoneSettings <a href="https://developers.cloudflare.com/api/go/resources/$shared#(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)">PermissionGrant</a>Optional

</summary>

Read boolOptional

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20zone_settings%20%2B%20(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)%20%3E%20(property)%20read">Link to this property</a>

Write boolOptional

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20zone_settings%20%2B%20(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)%20%3E%20(property)%20write">Link to this property</a>

</details>

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20zone_settings">Link to this property</a>

<details>

<summary>

Zones <a href="https://developers.cloudflare.com/api/go/resources/$shared#(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)">PermissionGrant</a>Optional

</summary>

Read boolOptional

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20zones%20%2B%20(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)%20%3E%20(property)%20read">Link to this property</a>

Write boolOptional

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20zones%20%2B%20(resource)%20%24shared%20%3E%20(model)%20permission_grant%20%3E%20(schema)%20%3E%20(property)%20write">Link to this property</a>

</details>

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions%20%3E%20(property)%20zones">Link to this property</a>

</details>

<a href="#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)%20%3E%20(property)%20permissions">Link to this property</a>

</details>

[Link to this property](<#(resource)%20%24shared%20%3E%20(model)%20role%20%3E%20(schema)>)

### List Roles

Go

HTTPTypeScriptPythonGoTerraform

```
package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/accounts"
  "github.com/cloudflare/cloudflare-go/option"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIKey("144c9defac04969c7bfad8efaa8ea194"),
    option.WithAPIEmail("user@example.com"),
  )
  page, err := client.Accounts.Roles.List(context.TODO(), accounts.RoleListParams{
    AccountID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"),
  })
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", page)
}
```

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": [
    {
      "id": "3536bcfad5faccb999b47003c79917fb",
      "description": "Administrative access to the entire Account",
      "name": "Account Administrator",
      "permissions": {
        "analytics": {
          "read": true,
          "write": false
        },
        "billing": {
          "read": true,
          "write": false
        },
        "cache_purge": {
          "read": true,
          "write": false
        },
        "dns": {
          "read": true,
          "write": false
        },
        "dns_records": {
          "read": true,
          "write": false
        },
        "lb": {
          "read": true,
          "write": false
        },
        "logs": {
          "read": true,
          "write": false
        },
        "organization": {
          "read": true,
          "write": false
        },
        "ssl": {
          "read": true,
          "write": false
        },
        "waf": {
          "read": true,
          "write": false
        },
        "zone_settings": {
          "read": true,
          "write": false
        },
        "zones": {
          "read": true,
          "write": true
        }
      }
    }
  ],
  "result_info": {
    "count": 1,
    "page": 1,
    "per_page": 20,
    "total_count": 2000
  }
}
```

##### Returns Examples

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": [
    {
      "id": "3536bcfad5faccb999b47003c79917fb",
      "description": "Administrative access to the entire Account",
      "name": "Account Administrator",
      "permissions": {
        "analytics": {
          "read": true,
          "write": false
        },
        "billing": {
          "read": true,
          "write": false
        },
        "cache_purge": {
          "read": true,
          "write": false
        },
        "dns": {
          "read": true,
          "write": false
        },
        "dns_records": {
          "read": true,
          "write": false
        },
        "lb": {
          "read": true,
          "write": false
        },
        "logs": {
          "read": true,
          "write": false
        },
        "organization": {
          "read": true,
          "write": false
        },
        "ssl": {
          "read": true,
          "write": false
        },
        "waf": {
          "read": true,
          "write": false
        },
        "zone_settings": {
          "read": true,
          "write": false
        },
        "zones": {
          "read": true,
          "write": true
        }
      }
    }
  ],
  "result_info": {
    "count": 1,
    "page": 1,
    "per_page": 20,
    "total_count": 2000
  }
}
```